<p>{{> theorie }}
    In der Praxis trifft man häufig den Fall an, dass nicht alle Daten in einer einzigen
    Tabelle vorliegen, sondern mehrere Tabellen existieren. An dieser Stelle kommen
    <code>JOINS</code> zum Einsatz, die dazu dienen, aus den Daten zweier Tabellen eine
    Ergebnistabelle zu bilden. Man unterscheidet zwischen <code>INNER JOIN</code>, <code>LEFT (OUTER) JOIN</code>,
    <code>RIGHT (OUTER)
                JOIN</code> und
    <code>FULL (OUTER) JOIN</code>.
</p>
<p>
    Für das bessere Verständnis soll die betrachtete Tabelle Schueler um ein weiteres
    Attribut erweitert werden: GTA_id. Zusätzlich existiert jetzt neben der Tabelle
    Schueler eine Tabelle GTA. Im Folgenden werden die genannten Join-Arten auf diesen Tabellen
    angewendet, um die Unterschiede besser darstellen zu können.
<div class="row justify-content-around">
    <div class="col-lg-6 col-md-8 col-sm-12 col-xs-12" style="padding-right: 4em;">
        <div>
            <h3>Schueler</h3>
        </div>
        <div class="table-responsive">
            <table class="table table-sm table-bordered" style="border-color: black;">
                <thead style="background-color: #f0f2f5;">
                    <tr>
                        <th>S_Nr</th>
                        <th>Nachname</th>
                        <th>Vorname</th>
                        <th>Klasse</th>
                        <th>GTA_Nr</th>
                    </tr>
                </thead>

                <body>
                    <tr>
                        <td>1</td>
                        <td>Kluge</td>
                        <td>Luca</td>
                        <td>10b</td>
                        <td>null</td>
                    </tr>
                    <tr>
                        <td>2</td>
                        <td>Ackermann</td>
                        <td>Katrin</td>
                        <td>9a</td>
                        <td>2</td>
                    </tr>
                    <tr>
                        <td>3</td>
                        <td>Boehm</td>
                        <td>Uwe</td>
                        <td>8c</td>
                        <td>1</td>
                    </tr>
                </body>
            </table>
        </div>
    </div>
    <div class="col-lg-6 col-md-8 col-sm-12 col-xs-12">
        <div>
            <h3>GTA</h3>
        </div>
        <div class="table-responsive">
            <table class="table table-sm table-bordered" style="border-color: black;">
                <thead style="background-color: #f0f2f5;">
                    <tr>
                        <th>GTA_Nr</th>
                        <th>Beschreibung</th>
                    </tr>
                </thead>

                <body>
                    <tr>
                        <td>1</td>
                        <td>Schach</td>
                    </tr>
                    <tr>
                        <td>2</td>
                        <td>Tastaturschreiben</td>
                    </tr>
                    <tr>
                        <td>3</td>
                        <td>Jugend forscht</td>
                    </tr>
                </body>
            </table>
        </div>
    </div>
</div>
<h3>(INNER) JOIN</h3>
<p>
    Der Inner Join liefert alle Daten zurück, die entsprechend der Bedingung
    (mit <b>ON</b> mitgeteilt) übereinstimmen.
</p>
<div class="container">
    <div class="row">
        <div class="col-sm">
            <pre class="db-code">
<code class="sql hljs">
SELECT Schueler.Vorname, GTA.Bezeichnung
FROM Schueler
INNER JOIN GTA
ON Schueler.GTA_Nr = GTA.GTA_Nr;
</code>
</pre>
        </div>
        <div class="col-sm">
            <table class="table table-sm table-bordered" style="border-color: black;">
                <thead style="background-color: #f0f2f5;">
                    <tr>
                        <th>Vorname</th>
                        <th>Bezeichnung</th>
                    </tr>
                </thead>

                <body>
                    <tr>
                        <td>Katrin</td>
                        <td>Tastaturschreiben</td>
                    </tr>
                    <tr>
                        <td>Uwe</td>
                        <td>Schach</td>
                    </tr>
                </body>
            </table>
        </div>
    </div>
</div>
<h3>LEFT (OUTER) JOIN</h3>
<p>
    Der LEFT OUTER JOIN liefert alle Daten der linken Tabelle zurück und weist ihnen die Daten der
    rechten Tabelle entsprechend der Bedingung zu.
</p>
<div class="container">
    <div class="row">
        <div class="col-sm">
            <pre class="db-code">
<code class="sql hljs">
SELECT Schueler.Vorname, GTA.Bezeichnung
FROM Schueler
LEFT JOIN GTA
ON Schueler.GTA_Nr = GTA.GTA_Nr;
</code>
</pre>
        </div>
        <div class="col-sm">
            <table class="table table-sm table-bordered" style="border-color: black;">
                <thead style="background-color: #f0f2f5;">
                    <tr>
                        <th>Vorname</th>
                        <th>Bezeichnung</th>
                    </tr>
                </thead>

                <body>
                    <tr>
                        <td>Luca</td>
                        <td>null</td>
                    </tr>
                    <tr>
                        <td>Katrin</td>
                        <td>Tastaturschreiben</td>
                    </tr>
                    <tr>
                        <td>Uwe</td>
                        <td>Schach</td>
                    </tr>
                </body>
            </table>
        </div>
    </div>
</div>
<h3>RIGHT (OUTER) JOIN</h3>
<p>
    Der RIGHT (OUTER) JOIN liefert alle Daten der rechten Tabelle zurück und weist ihnen die Daten der
    linken Tabelle entsprechend der Bedingung zu.
</p>

<div class="container">
    <div class="row">
        <div class="col-sm">
            <pre class="db-code">
<code class="sql hljs">
SELECT Schueler.Vorname, GTA.Bezeichnung
FROM Schueler
RIGHT JOIN GTA
ON Schueler.GTA_Nr = GTA.GTA_Nr;
</code>
</pre>
        </div>
        <div class="col-sm">
            <table class="table table-sm table-bordered" style="border-color: black">
                <thead style="background-color: #f0f2f5;">
                    <tr>
                        <th>Vorname</th>
                        <th>Bezeichnung</th>
                    </tr>
                </thead>

                <body>
                    <tr>
                        <td>Katrin</td>
                        <td>Tastaturschreiben</td>
                    </tr>
                    <tr>
                        <td>Uwe</td>
                        <td>Schach</td>
                    </tr>
                    <tr>
                        <td>null</td>
                        <td>Jugend forscht</td>
                    </tr>
                </body>
            </table>
        </div>
    </div>
</div>
<h3>
    FULL (OUTER) JOIN
</h3>
<p>
    Der FULL (OUTER) JOIN liefert alle Daten aus beiden Tabellen zurück und ordnet sie entsprechend der
    Bedingung einander zu.
</p>
<div class="container">
    <div class="row">
        <div class="col-sm">
            <pre class="db-code">
<code class="sql hljs">
SELECT Schueler.Vorname, GTA.Bezeichnung
FROM Schueler
FULL OUTER JOIN GTA
ON Schueler.GTA_Nr = GTA.GTA_Nr;
</code>
</pre>
        </div>
        <div class="col-sm">
            <table class="table table-sm table-bordered" style="border-color: black;">
                <thead style="background-color: #f0f2f5;">
                    <tr>
                        <th>Vorname</th>
                        <th>Bezeichnung</th>
                    </tr>
                </thead>

                <body>
                    <tr>
                        <td>Katrin</td>
                        <td>Tastaturschreiben</td>
                    </tr>
                    <tr>
                        <td>Uwe</td>
                        <td>Schach</td>
                    </tr>
                    <tr>
                        <td>Kluge</td>
                        <td>null</td>
                    </tr>
                    <tr>
                        <td>null</td>
                        <td>Jugend forscht</td>
                    </tr>
                </body>
            </table>
        </div>
    </div>
</div>

